#version 310 es
layout (local_size_x = 3, local_size_y = 2, local_size_z = 5) in;
layout(binding = 0) buffer Output {
    uint values[30];
} sb_out;

shared uint offsets[30];

void main (void) {
    uint localSize  = gl_WorkGroupSize.x*gl_WorkGroupSize.y*gl_WorkGroupSize.z;
    uint globalNdx  = gl_NumWorkGroups.x*gl_NumWorkGroups.y*gl_WorkGroupID.z + gl_NumWorkGroups.x*gl_WorkGroupID.y + gl_WorkGroupID.x;
    uint globalOffs = localSize*globalNdx;
    uint localOffs  = gl_WorkGroupSize.x*gl_WorkGroupSize.y*gl_LocalInvocationID.z + gl_WorkGroupSize.x*gl_LocalInvocationID.y + gl_LocalInvocationID.x;

    offsets[localSize-localOffs-1u] = globalOffs + localOffs*localOffs;
    barrier();
    sb_out.values[globalOffs + localOffs] = offsets[localOffs];
}
